Index: /trunk/sources/HeuristicLab.Core/EngineBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/EngineBase.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/EngineBase.cs	(revision 776)
@@ -27,10 +27,27 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Base class to represent an engine, which is an interpreter, holding the code, the data and 
+  /// the actual state, which is the runtime stack and a pointer onto the next operation. It represents
+  /// one execution and can handle parallel executions.
+  /// </summary>
   public abstract class EngineBase : ItemBase, IEngine {
+    /// <summary>
+    /// Field of the current instance that represent the operator graph.
+    /// </summary>
     protected IOperatorGraph myOperatorGraph;
+    /// <summary>
+    /// Gets the current operator graph.
+    /// </summary>
     public IOperatorGraph OperatorGraph {
       get { return myOperatorGraph; }
     }
+    /// <summary>
+    /// Field of the current instance that represent the global scope.
+    /// </summary>
     protected IScope myGlobalScope;
+    /// <summary>
+    /// Gets the current global scope.
+    /// </summary>
     public IScope GlobalScope {
       get { return myGlobalScope; }
@@ -38,4 +55,8 @@
 
     private TimeSpan myExecutionTime;
+    /// <summary>
+    /// Gets or sets the execution time.
+    /// </summary>
+    /// <remarks>Calls <see cref="OnExecutionTimeChanged"/> in the setter.</remarks>
     public TimeSpan ExecutionTime {
       get { return myExecutionTime; }
@@ -46,20 +67,47 @@
     }
 
+    /// <summary>
+    /// Field of the current instance that represent the execution stack.
+    /// </summary>
     protected Stack<IOperation> myExecutionStack;
+    /// <summary>
+    /// Gets the current execution stack.
+    /// </summary>
     public Stack<IOperation> ExecutionStack {
       get { return myExecutionStack; }
     }
+    
+    /// <summary>
+    /// Flag of the current instance whether it is currently running.
+    /// </summary>
     protected bool myRunning;
+    /// <summary>
+    /// Gets information whether the instance is currently running.
+    /// </summary>
     public bool Running {
       get { return myRunning; }
     }
+
+    /// <summary>
+    /// Flag of the current instance whether it is canceled.
+    /// </summary>
     protected bool myCanceled;
+    /// <summary>
+    /// Gets information whether the instance is currently canceled.
+    /// </summary>
     public bool Canceled {
       get { return myCanceled; }
     }
+    /// <summary>
+    /// Gets information whether the instance has already terminated.
+    /// </summary>
     public virtual bool Terminated {
       get { return ExecutionStack.Count == 0; }
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="EngineBase"/> with a new global scope.
+    /// </summary>
+    /// <remarks>Calls <see cref="Reset"/>.</remarks>
     protected EngineBase() {
       myOperatorGraph = new OperatorGraph();
@@ -69,4 +117,11 @@
     }
 
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Deep clone through <see cref="Auxiliary.Clone"/> method of helper class 
+    /// <see cref="Auxiliary"/>.</remarks>
+    /// <param name="clonedObjects">Dictionary of all already clone objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="EngineBase"/>.</returns>
     public override object Clone(IDictionary<Guid, object> clonedObjects) {
       EngineBase clone = (EngineBase)base.Clone(clonedObjects);
@@ -84,4 +139,7 @@
     }
 
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="ThreadPool.QueueUserWorkItem(System.Threading.WaitCallback, object)"/> 
+    /// of class <see cref="ThreadPool"/>.</remarks>
     public virtual void Execute() {
       myRunning = true;
@@ -89,4 +147,7 @@
       ThreadPool.QueueUserWorkItem(new WaitCallback(Run), null);
     }
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="ThreadPool.QueueUserWorkItem(System.Threading.WaitCallback, object)"/> 
+    /// of class <see cref="ThreadPool"/>.</remarks>
     public virtual void ExecuteSteps(int steps) {
       myRunning = true;
@@ -94,10 +155,20 @@
       ThreadPool.QueueUserWorkItem(new WaitCallback(Run), steps);
     }
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="ThreadPool.QueueUserWorkItem(System.Threading.WaitCallback, object)"/> 
+    /// of class <see cref="ThreadPool"/>.</remarks>
     public void ExecuteStep() {
       ExecuteSteps(1);
     }
+    /// <inheritdoc/>
+    /// <remarks>Sets the protected flag <c>myCanceled</c> to <c>true</c>.</remarks>
     public virtual void Abort() {
       myCanceled = true;
     }
+    /// <inheritdoc/>
+    /// <remarks>Sets <c>myCanceled</c> and <c>myRunning</c> to <c>false</c>. The global scope is cleared,
+    /// the execution time is reseted, the execution stack is cleared and a new <see cref="AtomicOperation"/>
+    /// with the initial operator is added. <br/>
+    /// Calls <see cref="OnInitialized"/>.</remarks>
     public virtual void Reset() {
       myCanceled = false;
@@ -142,17 +213,40 @@
     }
 
+    /// <summary>
+    /// Performs the next operation.
+    /// </summary>
     protected abstract void ProcessNextOperation();
 
+    /// <summary>
+    /// Occurs when the current instance is initialized.
+    /// </summary>
     public event EventHandler Initialized;
+    /// <summary>
+    /// Fires a new <c>Initialized</c> event.
+    /// </summary>
     protected virtual void OnInitialized() {
       if (Initialized != null)
         Initialized(this, new EventArgs());
     }
+    /// <summary>
+    /// Occurs when an operation is executed.
+    /// </summary>
     public event EventHandler<OperationEventArgs> OperationExecuted;
+    /// <summary>
+    /// Fires a new <c>OperationExecuted</c> event.
+    /// </summary>
+    /// <param name="operation">The operation that has been executed.</param>
     protected virtual void OnOperationExecuted(IOperation operation) {
       if (OperationExecuted != null)
         OperationExecuted(this, new OperationEventArgs(operation));
     }
+    /// <summary>
+    /// Occurs when an exception occured during the execution.
+    /// </summary>
     public event EventHandler<ExceptionEventArgs> ExceptionOccurred;
+    /// <summary>
+    /// Aborts the execution and fires a new <c>ExceptionOccurred</c> event.
+    /// </summary>
+    /// <param name="exception">The exception that was thrown.</param>
     protected virtual void OnExceptionOccurred(Exception exception) {
       Abort();
@@ -160,10 +254,22 @@
         ExceptionOccurred(this, new ExceptionEventArgs(exception));
     }
+    /// <summary>
+    /// Occurs when the execution time changed.
+    /// </summary>
     public event EventHandler ExecutionTimeChanged;
+    /// <summary>
+    /// Fires a new <c>ExecutionTimeChanged</c> event.
+    /// </summary>
     protected virtual void OnExecutionTimeChanged() {
       if (ExecutionTimeChanged != null)
         ExecutionTimeChanged(this, new EventArgs());
     }
+    /// <summary>
+    /// Occurs when the execution is finished.
+    /// </summary>
     public event EventHandler Finished;
+    /// <summary>
+    /// Fires a new <c>Finished</c> event.
+    /// </summary>
     protected virtual void OnFinished() {
       if (Finished != null)
@@ -172,4 +278,33 @@
 
     #region Persistence Methods
+    /// <summary>
+    /// Saves the current instance as <see cref="XmlNode"/> in the specified <paramref name="document"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="StorableBase.GetXmlNode"/> of base class <see cref="ItemBase"/>.<br/>
+    /// A quick overview how the single elements of the current instance are saved:
+    /// <list type="bullet">
+    /// <item>
+    /// <term>Operator graph: </term>
+    /// <description>Saved as a child node with the tag name <c>OperatorGraph</c>.</description>
+    /// </item>
+    /// <item>
+    /// <term>Global scope: </term>
+    /// <description>Saved as a child node with the tag name <c>GlobalScope</c>.</description> 
+    /// </item>
+    /// <item>
+    /// <term>Execution stack: </term>
+    /// <description>A child node is created with the tag name <c>ExecutionStack</c>. Beyond this child node
+    /// all operations of the execution stack are saved as child nodes.</description>
+    /// </item>
+    /// <item>
+    /// <term>Execution time: </term>
+    /// <description>Saved as a child node with the tag name <c>ExecutionTime</c>, where the execution
+    /// time is saved as string in the node's inner text.</description>
+    /// </item>
+    /// </list></remarks>
+    /// <param name="name">The (tag)name of the <see cref="XmlNode"/>.</param>
+    /// <param name="document">The <see cref="XmlDocument"/> where to save the data.</param>
+    /// <param name="persistedObjects">The dictionary of all already persisted objects. (Needed to avoid cycles.)</param>
+    /// <returns>The saved <see cref="XmlNode"/>.</returns>
     public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid,IStorable> persistedObjects) {
       XmlNode node = base.GetXmlNode(name, document, persistedObjects);
@@ -190,4 +325,12 @@
       return node;
     }
+    /// <summary>
+    ///  Loads the persisted instance from the specified <paramref name="node"/>.
+    /// </summary>
+    /// <remarks>See <see cref="GetXmlNode"/> to get information on how the instance must be saved. <br/>
+    /// Calls <see cref="StorableBase.Populate"/> of base class <see cref="ItemBase"/>.</remarks>
+    /// <param name="node">The <see cref="XmlNode"/> where the engine is saved.</param>
+    /// <param name="restoredObjects">The dictionary of all already restored objects. 
+    /// (Needed to avoid cycles.)</param>
     public override void Populate(XmlNode node, IDictionary<Guid,IStorable> restoredObjects) {
       base.Populate(node, restoredObjects);
Index: /trunk/sources/HeuristicLab.Core/EngineBaseEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/EngineBaseEditor.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/EngineBaseEditor.cs	(revision 776)
@@ -30,7 +30,14 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Base class for editors of engines.
+  /// </summary>
   public partial class EngineBaseEditor : EditorBase {
     private int executionTimeCounter;
 
+    /// <summary>
+    /// Gets or sets the current engine.
+    /// </summary>
+    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="EditorBase"/>.</remarks>
     public IEngine Engine {
       get { return (IEngine)Item; }
@@ -38,8 +45,15 @@
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="EngineBaseEditor"/>.
+    /// </summary>
     public EngineBaseEditor() {
       InitializeComponent();
     }
 
+    /// <summary>
+    /// Removes the event handlers from the underlying <see cref="IEngine"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
     protected override void RemoveItemEvents() {
       Engine.Initialized -= new EventHandler(Engine_Initialized);
@@ -51,4 +65,8 @@
       base.RemoveItemEvents();
     }
+    /// <summary>
+    /// Adds event handlers to the underlying <see cref="IEngine"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
     protected override void AddItemEvents() {
       base.AddItemEvents();
@@ -61,4 +79,8 @@
     }
 
+    /// <summary>
+    /// Updates all controls with the latest data of the model.
+    /// </summary>
+    /// <remarks>Calls <see cref="EditorBase.UpdateControls"/> of base class <see cref="EditorBase"/>.</remarks>
     protected override void UpdateControls() {
       base.UpdateControls();
Index: /trunk/sources/HeuristicLab.Core/ExceptionEventArgs.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/ExceptionEventArgs.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/ExceptionEventArgs.cs	(revision 776)
@@ -25,10 +25,21 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Event arguments to be able to specify the affected exception.
+  /// </summary>
   public class ExceptionEventArgs : EventArgs {
     private Exception myException;
+    /// <summary>
+    /// Gets the affected exception.
+    /// </summary>
     public Exception Exception {
       get { return myException; }
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="ExceptionEventArgs"/> 
+    /// with the given <paramref name="exception"/>.
+    /// </summary>
+    /// <param name="exception">The affected exception.</param>
     public ExceptionEventArgs(Exception exception) {
       myException = exception;
Index: /trunk/sources/HeuristicLab.Core/HeuristicLab.Core.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/HeuristicLab.Core.csproj	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/HeuristicLab.Core.csproj	(revision 776)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{F43B59AB-2B8C-4570-BC1E-15592086517C}</ProjectGuid>
Index: /trunk/sources/HeuristicLab.Core/HeuristicLabCorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/HeuristicLabCorePlugin.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/HeuristicLabCorePlugin.cs	(revision 776)
@@ -27,4 +27,7 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Plugin class for HeuristicLab.Core plugin.
+  /// </summary>
   [ClassInfo(Name = "HeuristicLab.Core-3.2")]
   [PluginFile(Filename = "HeuristicLab.Core-3.2.dll", Filetype = PluginFileType.Assembly)]
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IConstrainedItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IConstrainedItem.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IConstrainedItem.cs	(revision 776)
@@ -25,14 +25,43 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent items that are subjects to restrictions. 
+  /// </summary>
   public interface IConstrainedItem : IItem {
+    /// <summary>
+    /// All constraints of the current instance. 
+    /// </summary>
     ICollection<IConstraint> Constraints { get; }
 
+    /// <summary>
+    /// Adds a constraint to the current instance.
+    /// </summary>
+    /// <param name="constraint">The constraint to add.</param>
     void AddConstraint(IConstraint constraint);
+    /// <summary>
+    /// Removes a constraint from the current instance.
+    /// </summary>
+    /// <param name="constraint">The constraint to remove.</param>
     void RemoveConstraint(IConstraint constraint);
 
+    /// <summary>
+    /// Checks whether the current instance fullfills all constraints.
+    /// </summary>
+    /// <returns><c>true</c> if all constraints are fullfilled, <c>false</c> otherwise.</returns>
     bool IsValid();
+    /// <summary>
+    /// Checks whether the current instance fullfills all constraints.
+    /// </summary>
+    /// <param name="violatedConstraints">Output parameter, all constraints that could not be fullfilled.</param>
+    /// <returns><c>true</c> if all constraints are fullfilled, <c>false</c> otherwise.</returns>
     bool IsValid(out ICollection<IConstraint> violatedConstraints);
 
+    /// <summary>
+    /// An <see cref="EventHandler"/> for events when a new constraint is added.
+    /// </summary>
     event EventHandler<ConstraintEventArgs> ConstraintAdded;
+    /// <summary>
+    /// An <see cref="EventHandler"/> for events when a constraint is deleted.
+    /// </summary>
     event EventHandler<ConstraintEventArgs> ConstraintRemoved;
   }
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IConstraint.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IConstraint.cs	(revision 776)
@@ -25,7 +25,18 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent restrictions.
+  /// </summary>
   public interface IConstraint : IItem {
+    /// <summary>
+    /// Gets the description of the current instance.
+    /// </summary>
     string Description { get; }
 
+    /// <summary>
+    /// Checks whether the given <paramref name="data"/> fulfills the current constraint.
+    /// </summary>
+    /// <param name="data">The item to check.</param>
+    /// <returns><c>true</c> if the current instance could be fulfilled, <c>false</c> otherwise.</returns>
     bool Check(IItem data);
   }
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IEditable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IEditable.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IEditable.cs	(revision 776)
@@ -25,5 +25,12 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent editable items.
+  /// </summary>
   public interface IEditable : IViewable {
+    /// <summary>
+    /// Creates an editor.
+    /// </summary>
+    /// <returns>The created editor as <see cref="IEditor"/>.</returns>
     IEditor CreateEditor();
   }
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IEditor.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IEditor.cs	(revision 776)
@@ -25,7 +25,17 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent an editor.
+  /// </summary>
   public interface IEditor : IView {
+
+    /// <summary>
+    /// Gets or sets the filename.
+    /// </summary>
     string Filename { get; set; }
 
+    /// <summary>
+    /// Occurs when the filename was changed.
+    /// </summary>
     event EventHandler FilenameChanged;
   }
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IEngine.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IEngine.cs	(revision 776)
@@ -25,24 +25,78 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent one run. (An engine is an interpreter, holding the code, 
+  /// the data and the actual state, which is the runtime stack and a pointer onto the next operation.).
+  /// It is responsible for operator execution and able to deal with parallelism.
+  /// </summary>
   public interface IEngine : IItem {
+    /// <summary>
+    /// Gets the operator graph of the current instance.
+    /// </summary>
     IOperatorGraph OperatorGraph { get; }
+    /// <summary>
+    /// Gets the global scope of the current instance.
+    /// </summary>
     IScope GlobalScope { get; }
 
+    /// <summary>
+    /// Gets the execution time of the current instance.
+    /// </summary>
     TimeSpan ExecutionTime { get; }
 
+    /// <summary>
+    /// Gets information whether the engine is currently running.
+    /// </summary>
     bool Running { get; }
+    /// <summary>
+    /// Gets information whether the engine is canceled.
+    /// </summary>
     bool Canceled { get; }
+    /// <summary>
+    /// Gets information whether the engine has already terminated.
+    /// </summary>
     bool Terminated { get; }
 
+    /// <summary>
+    /// Executes the whole run.
+    /// </summary>
     void Execute();
+    /// <summary>
+    /// Executes one step (one operation).
+    /// </summary>
     void ExecuteStep();
+    /// <summary>
+    /// Executes the given number of steps.
+    /// </summary>
+    /// <param name="steps">The number of steps to execute.</param>
     void ExecuteSteps(int steps);
+    /// <summary>
+    /// Aborts the engine run.
+    /// </summary>
     void Abort();
+    /// <summary>
+    /// Resets the current instance.
+    /// </summary>
     void Reset();
 
+    /// <summary>
+    /// Occurs when the current instance is initialized.
+    /// </summary>
     event EventHandler Initialized;
+    /// <summary>
+    /// Occurs when an operation is executed.
+    /// </summary>
     event EventHandler<OperationEventArgs> OperationExecuted;
+    /// <summary>
+    /// Occurs when an exception was thrown.
+    /// </summary>
     event EventHandler<ExceptionEventArgs> ExceptionOccurred;
+    /// <summary>
+    /// Occurs when the execution time was changed.
+    /// </summary>
     event EventHandler ExecutionTimeChanged;
+    /// <summary>
+    /// Occurs when the engine is finished.
+    /// </summary>
     event EventHandler Finished;
   }
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IItem.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IItem.cs	(revision 776)
@@ -25,7 +25,16 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent (almost) every HeuristicLab object (an object, an operator,...).
+  /// </summary>
   public interface IItem : IStorable, IViewable {
+    /// <summary>
+    /// Fires a new <c>Changed</c> event.
+    /// </summary>
     void FireChanged();
 
+    /// <summary>
+    /// Occurs when the current instance has changed.
+    /// </summary>
     event EventHandler Changed;
   }
Index: /trunk/sources/HeuristicLab.Core/Interfaces/IOperation.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/Interfaces/IOperation.cs	(revision 775)
+++ /trunk/sources/HeuristicLab.Core/Interfaces/IOperation.cs	(revision 776)
@@ -25,4 +25,7 @@
 
 namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent an operation (Executes a defined number of operators on a defined scope). 
+  /// </summary>
   public interface IOperation : IItem {
   }
